//javascript dátum, idő számláló megjelenítő
//Kőrösi József, 2012. szeptember
//jozsi1978@windowslive.com

////////////////////////////////////////////////////////////////////////////////////////////////////
//javascript dátum, idő számláló megjelenítő függvényei:
//			-image_precache
//			-graph_text_output
//			-display_date_time_counter

function image_precache(image_path,image_style,character_count)
{
	var digits_array=new Array();
	for(var i=0;i<=(character_count-1);i++)
	{
		digits_array[i]=new Array();
		for(var j=0;j<=9;j++)
		{
			digits_array[i][j]=new Image();
			digits_array[i][j].src=image_path+image_style+'/'+image_style+'_'+j+'.png';
		}
		digits_array[i][10]=new Image();
		digits_array[i][10].src=image_path+image_style+'/'+image_style+'_selector_1.png';
		digits_array[i][11]=new Image();
		digits_array[i][11].src=image_path+image_style+'/'+image_style+'_selector_2.png';
		digits_array[i][12]=new Image();
		digits_array[i][12].src=image_path+image_style+'/'+image_style+'_selector_3.png';
	}
	return digits_array;
}

function graph_text_output(containing_element,text,alt,title,image_array)
//Ez a függvény a megjeleníteni kívánt szöveg karaktereit kicseréli a meghatározott képekre.

//containing_element		:az a html elem, amihez hozzácsatoljuk a képeket, üres elemet kell megadni, más ne legyen benne
//text						:a megjeleníteni kívánt szöveg
//alt						:a karakterek képeihez rendelt alternatív szöveg
//title						:a karakterek képeihez rendelt cím
//image_array				:a karakterek képeit tartalmazó tömb
{
	var characters=text.split('');					
	var text_as_graphic=new Array();
	var digit='';
	var count=0;
	
	for(var i=0;i<characters.length;i++)
	{
		//A megjeleníthető karakterek: '0123456789.:/'
		//Alapértelmezés szerint a 'digit' változónak -1 értéke van, ezzel a függvény eltávolítja a
		//meg nem jeleníthető karaktereket
		digit=-1;
		switch(characters[i])
		{
			case '0':{digit= 0;}break;
			case '1':{digit= 1;}break;
			case '2':{digit= 2;}break;
			case '3':{digit= 3;}break;
			case '4':{digit= 4;}break;
			case '5':{digit= 5;}break;
			case '6':{digit= 6;}break;
			case '7':{digit= 7;}break;
			case '8':{digit= 8;}break;
			case '9':{digit= 9;}break;
			case '.':{digit=10;}break;
			case ':':{digit=11;}break;
			case '/':{digit=12;}break;
		}
		if(digit!=-1)
		{
			text_as_graphic[count]=image_array[i][digit];
			text_as_graphic[count].alt=alt;
			text_as_graphic[count].title=title;
			count++;
		}
	}
	//a képeket tartalmazó elem kiürítése
	$(containing_element).empty();
	//a megjeleníthető karakterek képként történő beillesztése
	for (var i=0;i<=count;i++)
	{
		$(containing_element).append(text_as_graphic[i]);
	}
}

function display_date_time_counter(text,display_format,containing_element,alt,title,image_array)
//Ez a függvény lekérdezi a dátum- és időadatokat és a megadott formátumba alakítás után átadja a 
//többi paraméterrel együtt a 'graph_text_output' függvénynek.
//
//text							:a megjeleníteni kívánt szöveg, amennyiben nem időt vagy dátumot
//								 akarunk megjeleníteni
//display format				:a dátum- és időmegjelenítés formátuma, az alábbiakból lehet 
//								 választani (szövegként kell megadni):
//	'hourmin'					:óra és perc							(megjelenés: '18:25'	   )
//	'hourminsecond'				:óra, perc, másodperc					(megjelenés: '18:25:48'	   )
//	'hourminsecondmillisecond'	:óra, perc, másodperc, ezredmásodperc	(megjelenés: '18:25:48.655')
//	'yearmonthday_1'			:év, hónap, nap pont elválasztóval		(megjelenés: '2012.07.18.' )
//	'yearmonthday_2'			:év, hónap, nap per-jel elválasztóval	(megjelenés: '2012/07/18'  )
//	'raw_text'					:nyers szöveg, számlálóhoz elsősorban	(megjelenés: '00162255'	   )

//containing_element			:az a html elem, amihez hozzácsatoljuk a képeket, üres elemet 
//								 kell megadni, más ne legyen benne, például:'#clock_area',
//								 css kijelölő stílusú elnevezést kell használni, például:
//								 '#info_area #date_display'
//alt							:a karakterek képeihez rendelt alternatív szöveg
//title							:a karakterek képeihez rendelt cím
//image_array					:a karakterek képeit tartalmazó tömb, amit előzőleg létre kell hozni

{
	//dátum- és időadatok lekérdezése
	var actual_date			=new Date();
	var year				=actual_date.getFullYear();
	var month				=actual_date.getMonth()+1;
	var day					=actual_date.getDate();
	var hour				=actual_date.getHours();
	var minute				=actual_date.getMinutes();
	var second				=actual_date.getSeconds();
	var millisecond			=actual_date.getMilliseconds();

	//a vezető nullák hozzáadása, ahol kell
	if(month<10)
	{
		month='0'+month;
	}
	if(day<10)
	{
		day='0'+day;
	}
	if(hour<10)
	{
		hour='0'+hour;
	}
	if(minute<10)
	{
		minute='0'+minute;
	}
	if(second<10)
	{
		second='0'+second;
	}
	if(millisecond<10)
	{
		millisecond='0'+millisecond;
	}
	if(millisecond<100)
	{
		millisecond='0'+millisecond;
	}

	//a paraméterként megasdott 'display_format' változó alapján a megjelenítendő szöveg összerakása
	switch(display_format)
	{
		case'hourmin'					:{formatted_text=hour+':'+minute;							}break;
		case'hourminsecond'				:{formatted_text=hour+':'+minute+':'+second;				}break;
		case'hourminsecondmillisecond'	:{formatted_text=hour+':'+minute+':'+second+'.'+millisecond;}break;
		case'yearmonthday_1'			:{formatted_text=year+'.'+month+'.'+day+'.';				}break;
		case'yearmonthday_2'			:{formatted_text=year+'/'+month+'/'+day;					}break;
		case'raw_text'					:{formatted_text=text;										}break;
	}

	//a szöveg és a többi paraméter átadása a megjelenítést végző 'graph_text_output' függvénynek
	graph_text_output(containing_element,formatted_text,alt,title,image_array);
}
//javascript dátum, idő számláló megjelenítő függvényei vége
////////////////////////////////////////////////////////////////////////////////////////////////////